# Copyright (c) 2008,2009 SFB/TR-55
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#    * Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#
#    * Redistributions in binary form must reproduce the above copyright
#      notice, this list of conditions and the following disclaimer in
#      the documentation and/or other materials provided with the
#      distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

package globsig;

use strict;

sub muxilla($$) {

    my ($upperleft, $lowerright) = @_;

    $ENV{GLOBSIG_DAEMONIP} = exists $ENV{GLOBSIG_DAEMONIP} ? $ENV{GLOBSIG_DAEMONIP} : "localhost";
    die "need environment GLOBSIG_AVOID"    unless exists $ENV{GLOBSIG_AVOID};
    die "need environment GLOBSIG_MUX"      unless exists $ENV{GLOBSIG_MUX};
    die "need environment GLOBSIG_CABLES"   unless exists $ENV{GLOBSIG_CABLES};
    die "need environment GLOBSIG_PART"     unless exists $ENV{GLOBSIG_PART};
    die "need environment GLOBSIG_NAMES"    unless exists $ENV{GLOBSIG_NAMES};
    die "need environment GLOBSIG_UPART"    unless exists $ENV{GLOBSIG_UPART};
    die "need environment GLOBSIG_UNAMES"   unless exists $ENV{GLOBSIG_UNAMES};

    my $userpart = <<here;
    <qpartition>
       <partition>
            <name>gs-auto-part</name>
            <upperleft>$upperleft</upperleft>
            <lowerright>$lowerright</lowerright>
        </partition>
    </qpartition>
here

    open(my $up, ">", "$ENV{GLOBSIG_UPART}");
    print $up $userpart;

    my $muxout = "";
    if (exists $ENV{GLOBSIG_UNAMES}) {
        $muxout = qx(muxilla.py -a $ENV{GLOBSIG_DAEMONIP} -A $ENV{GLOBSIG_AVOID}\\
            -M $ENV{GLOBSIG_MUX} -C $ENV{GLOBSIG_CABLES} -P $ENV{GLOBSIG_PART}\\
            -N $ENV{GLOBSIG_NAMES} -U $ENV{GLOBSIG_UPART} -S $ENV{GLOBSIG_UNAMES} );
    }
    else {
        $muxout = qx(muxilla.py -a $ENV{GLOBSIG_DAEMONIP} -A $ENV{GLOBSIG_AVOID}\\
            -M $ENV{GLOBSIG_MUX} -C $ENV{GLOBSIG_CABLES} -P $ENV{GLOBSIG_PART}\\
            -N $ENV{GLOBSIG_NAMES});
    }
    my @lines = split /\n/, "$muxout";
    for my $line (@lines) {
        if ($line =~ /^ERRORS: (.*)/) {
            print $muxout;
            die "There were errors in globsig." if ($1 != 0);
        }
    }
}

1;
